#include <iostream> 
#include <fstream>
#include <utility>
#include <string>
#include <vector>
#include <ctime>
#include <map>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <sstream>
#ifndef OD_H
#define OD_H

using namespace std;
// OD STRUCTS AND CLASSES
struct ODPair
{
    int s;
    int t;
    int flow;
    ODPair(int i, int j, int k)
    {
       s=i; t=j; flow=k; 
    }
};

class OD
{
    public:
        vector<ODPair> pairs;
        int numIncrements;
        int numBatches;
        OD(int, int);
        OD getBatch(int);
        int totalTrips();
        void fromFile(string);
};

OD::OD( int nI, int nB )
{
    numIncrements = nI;
    numBatches = nB;
}

OD OD::getBatch(int b)
{
    OD new_od = OD(1,1);
    int batch_size = pairs.size()/numBatches;
    int batch_flow;
    int flow_remainder;

    for( int i=b*batch_size; i<(b+1)*batch_size; i++)
    {
        ODPair new_pair = pairs[i];
        batch_flow = new_pair.flow/numIncrements;
        flow_remainder = new_pair.flow % numIncrements;
        new_pair.flow = batch_flow;
        if (rand() % numBatches == b)
            new_pair.flow += flow_remainder;
        if (new_pair.flow > 0) new_od.pairs.push_back( new_pair );
    }
    return new_od;
}

int OD::totalTrips()
{
    int total = 0;
    for (int i=0; i<pairs.size(); i++)
        total += pairs[i].flow;
    return total;
}

void OD::fromFile(string fname)
{
    //OD od = OD(increments, batches);
    ODPair odp(1,1,1);

    ifstream fid (fname.c_str());
    string head;
    getline(fid, head);
    while (fid >> odp.s)
    {
        fid >> odp.t;
        fid >> odp.flow;
        odp.s--;
        odp.t--;
        pairs.push_back( odp );
    }

    fid.close();
}
#endif
